/*
	$Id$
	edb_survey--- surveyer
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id$";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<string.h>
#include	<signal.h>
#include	"edb/edb.h"
#include	"edb/html.h"
#include	"edb/publish.h"

static	int	edb_survey	__P((char *, char *, int, char *[]));


int	edb_make_books			__P((EdbContext, int, char *[], FILE *));
int	edb_make_survey			__P((EdbContext, int, char *[], FILE *));

static
struct {
	char	*cmd;
	char	*lang;
	eid_t	operator;
	int	staff;
	int	(*func)	__P((EdbContext, int, char *[], FILE *));
} command_list[] = {
{	"book",		"Japanese",	0,	FALSE,	edb_make_books	},
{	"survey",		"Japanese",	0,	FALSE,	edb_make_survey	},
};

/*#main--- main function */
int
main(int ac, char *av[])
{
	char	*dbname = NULL;
	int	new_ac;
	char	*new_av[100];
	int	i;

	new_ac = 0;
	for(i=1; i<ac; ++i) {
		if(!strcmp(av[i], "-D") && i+1<ac) {
			dbname = av[i+1];
			++i;
		} else {
			new_av[new_ac++] = av[i];
		}
	}

	if(ac>1) {
		edb_survey(dbname, new_av[0], new_ac-1, &new_av[1]);
	} else {
		fprintf(stderr, "usage: %s <command> <arg1> <arg2>...\n", av[0]);
	}
	exit(0);
}

static
int
edb_survey(char *db, char *cmd, int ac, char *av[])
{
	int	i, status;
	EdbContext	ec;

	ec = edb_configure(PUBLIC_DBCONF);
	ec->university = TRUE;
	if(db) edb_dbpath_set(ec, db, TRUE);

	if(!edb_open(ec)) {
		fprintf(stderr, "edb_survey: can't open database\n");
		return FALSE;
	}
	edb_trace_set(ec, stdout);

	for(i=0; i<Ns(command_list); ++i) {
		if(!strcasecmp(cmd, command_list[i].cmd)) {
			if(command_list[i].func) {
				if(command_list[i].lang) {
					edb_setdatabasespeaking(ec, command_list[i].lang);
				}
				ec->operator = command_list[i].operator;
				ec->staff = command_list[i].staff;
				status = (*command_list[i].func)(ec, ac, av, stdout);
			}
			break;
		}
	}

	edb_close(ec);
	return status;
}


