/*
	$Id: mod_conference.c,v 1.7 2005/05/23 08:06:43 alex Exp $
	mod_thesis.c---
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: mod_conference.c,v 1.7 2005/05/23 08:06:43 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<ctype.h>
#include	<string.h>
#include	"edb/edb.h"
#include	"edb/html.h"
#include	"edb/publish.h"

#define	EDB_NATION_A_INTL_EID		10062

static
int
print_role(EdbPrint ep, EdbTupleInfo tuple, EdbDatum super_datum)
{
	register int	status;

	if(super_datum==NULL) return FALSE;
	edb_print_push(ep);
	ep->ct->tcd_mode &= ~EP_TCD_MODE_BOLD;
	status = edb_print_tuple_named_column(ep, tuple, super_datum, " (", "", "@.role", NULL, ", ", ")", NULL, EP_ALERT);
	edb_print_pop(ep);
	return status;
}

static
int
edb_book_print_conference(EdbPrint ep, EdbTupleInfo tuple)
{
	register Doc	doc = ep->doc;
	EdbTupleColumn	tc;
	EdbDatum	datum;
	int	japanese = TRUE;
	eid_t	eid;
	int	i, num;
	int	status = EP_STATUS_NORMAL;
	char	*comma = ", ";
	Link	l;

	edb_print_push(ep);
	edb_print_tuple_prefix(ep, tuple);

	if(EpLang(ep)==EP_LANG_Auto) {
		tc = edb_tuple_seek_column(ep->ec, tuple, (utf8_t *)"@.class1");
		if(tc && (datum=TCDatumFirst(tc)) && DatumEIDisValid(datum) && DatumEID(datum) == EDB_NATION_A_INTL_EID) japanese = FALSE;
		TeX(doc) if(!japanese) doc_puts(doc, "\\英文");
		comma = ", ";

		EpLang(ep) = japanese ? EP_LANG_Japanese : EP_LANG_English;
	}

	edb_print_push(ep);
	ep->ct->tcd_mode = EP_TCD_MODE_BOLD;
	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.promoter", print_role, ", ", "", NULL, EP_ALERT);
	edb_print_pop(ep);
	edb_book_print_delimiter(ep, status, " : ");

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.society", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, comma);

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.class2", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, comma);

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.name", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, comma);

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.location", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, comma);

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.period", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, TRUE, ".");

	edb_print_tuple_postfix(ep, tuple);
	edb_print_pop(ep);
	return status;
}


static struct EDB_PRINT_MODULE_INFO module_info = {
/* xmlname */	EDB_TABLE_Conference_XN,
/* language */	NULL,
/* std */	edb_book_print_conference,
/* xml */	NULL,
/* csv */	NULL,
/* item */	NULL,
/* cap */	edb_book_print_conference
};
DECLARE_PRINT_MODULE(conference, module_info)




