/*
	$Id: mod_researchactivity.c,v 1.6 2005/05/23 08:06:43 alex Exp $
	mod_researchactivity.c---
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: mod_researchactivity.c,v 1.6 2005/05/23 08:06:43 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<ctype.h>
#include	<string.h>
#include	"edb/edb.h"
#include	"edb/html.h"
#include	"edb/publish.h"

#define	EDB_NATION_A_INTL_EID		10062

#define	RESEARCH_MOE	0
#define	RESEARCH_INTL	1
#define	RESEARCH_CO		2

static
int
edb_book_kind_of_research(EdbPrint ep, EdbTupleInfo tuple)
{
	EdbTupleColumn	tc;
	int	kind = RESEARCH_CO;
	EdbDatum	datum;

	tc = edb_tuple_seek_column(ep->ec, tuple, (utf8_t *)"@.sponsor");
	if(tc && (datum=TCDatumFirst(tc)) && DatumEIDisValid(datum)
		&& (DatumEID(datum) == 11067 || DatumEID(datum)  == 12334 || DatumEID(datum)  == 15938)) kind = RESEARCH_MOE;
	tc = edb_tuple_seek_column(ep->ec, tuple, (utf8_t *)"@.kind");
	if(tc && (datum=TCDatumFirst(tc)) && DatumEIDisValid(datum) && DatumEID(datum) == EDB_NATION_A_INTL_EID) kind = RESEARCH_INTL;
	return kind;
}

static
int
edb_book_print_research(EdbPrint ep, EdbTupleInfo tuple)
{
	register Doc	doc = ep->doc;
	int	kind;
	int	status = EP_STATUS_NORMAL;
	int	japanese = TRUE;

	edb_print_push(ep);
	if(EpLang(ep)==EP_LANG_Auto) EpLang(ep) = EP_LANG_Japanese;
	edb_print_tuple_prefix(ep, tuple);
	kind = edb_book_kind_of_research(ep, tuple);

	CSV(ep) {
		status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.organization", NULL, ", ", "", NULL, EP_ALERT);
		edb_book_print_delimiter(ep, status, ", ");
	}
	edb_print_push(ep);
	ep->ct->column_mode |= EP_COLUMN_MODE_LIST_AND;
	ep->ct->tcd_mode |= EP_TCD_MODE_BOLD;
	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.researcher", NULL, ", ", "", NULL, EP_ALERT);
	edb_print_pop(ep);
	edb_book_print_delimiter(ep, status, " : ");

	CSV(ep) {
		status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.kind", NULL, ", ", "", NULL, EP_ALERT);
		edb_book_print_delimiter(ep, status, ", ");
		status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.sponsor", NULL, ", ", "", NULL, EP_ALERT);
		edb_book_print_delimiter(ep, status, ", ");
		status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.budget", NULL, ", ", "", NULL, EP_ALERT);
		edb_book_print_delimiter(ep, status, ", ");
		status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.budget2", NULL, ", ", "", NULL, EP_WARNING);
		edb_book_print_delimiter(ep, status, ", ");
	} else {
		status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.sponsor", NULL, ", ", "", NULL, EP_ALERT);
		edb_book_print_delimiter(ep, status, ", ");
		status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.budget", NULL, ", ", "", NULL, EP_ALERT);
		edb_book_print_delimiter(ep, status, "・");
		status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.budget2", NULL, ", ", "", NULL, (kind==RESEARCH_MOE) ? EP_ALERT : EP_WARNING);
		edb_book_print_delimiter(ep, status, ", ");
	}

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.theme", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, ", ");

	CSV(ep) {
		status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.amount", NULL, ", ", "", NULL, EP_WARNING);
		edb_book_print_delimiter(ep, status, ", ");
	}

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.period", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, TRUE, ".");

	edb_print_tuple_postfix(ep, tuple);
	edb_print_pop(ep);

	return status;
}

static struct EDB_PRINT_MODULE_INFO module_info = {
/* xmlname */	EDB_TABLE_ResearchActivity_XN,
/* language */	NULL,
/* std */	edb_book_print_research,
/* xml */	NULL,
/* csv */	NULL,
/* item */	NULL,
/* cap */	edb_book_print_research
};
DECLARE_PRINT_MODULE(researchactivity, module_info)

