/*
	$Id: mod_socialactivity.c,v 1.3 2011/04/18 09:45:59 alex Exp $
	mod_socialactivity.c---
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: mod_socialactivity.c,v 1.3 2011/04/18 09:45:59 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<ctype.h>
#include	<string.h>
#include	"edb/edb.h"
#include	"edb/html.h"
#include	"edb/publish.h"

static
int
print_researcher(EdbPrint ep, EdbTupleInfo tuple, EdbDatum super_datum)
{
	register int	status;

	if(super_datum==NULL) return FALSE;
	edb_print_push(ep);
	ep->ct->tcd_mode |= EP_TCD_MODE_BOLD;
	status = edb_print_tuple_named_column(ep, tuple, super_datum, " (", "", "@.researcher", NULL, ", ", ")", NULL, EP_ALERT);
	edb_print_pop(ep);
	return status;
}

static
int
print_period(EdbPrint ep, EdbTupleInfo tuple, EdbDatum super_datum)
{
	register int	status;

	if(super_datum==NULL) return FALSE;
	status = edb_print_tuple_named_column(ep, tuple, super_datum, " [", "", "@.period", NULL, ", ", "]", "", EP_ALERT);
	return status;
}

static
int
edb_book_print_socialactivity(EdbPrint ep, EdbTupleInfo tuple)
{
	register Doc	doc = ep->doc;
	int	status = EP_STATUS_NORMAL;

	edb_print_push(ep);
	if(EpLang(ep)==EP_LANG_Auto) EpLang(ep) = EP_LANG_Japanese;

	edb_print_tuple_prefix(ep, tuple);

	edb_print_push(ep);
	ep->ct->tcd_mode |= EP_TCD_MODE_BOLD;
	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.person", NULL, ", ", "", NULL, EP_ALERT);
	edb_book_print_delimiter(ep, status, " : ");
	edb_print_pop(ep);

	status = edb_print_tuple_named_column(ep, tuple, NULL, "", "", "@.organization", NULL, ", ", "", NULL, EP_ALERT);
	if(PrintStyleIsSTANDARD(ep)) {
		edb_book_print_delimiter(ep, TRUE, ", ");
		status = edb_print_tuple_named_column(ep, tuple, NULL, " (", "", "@.post", print_period, ", ", ")", "", 0);
	}
	edb_book_print_delimiter(ep, TRUE, ".");

	edb_print_tuple_postfix(ep, tuple);
	edb_print_pop(ep);

	return status;
}

static struct EDB_PRINT_MODULE_INFO module_info = {
/* xmlname */	"socialactivity",
/* language */	NULL,
/* std */	edb_book_print_socialactivity,
/* xml */	NULL,
/* csv */	NULL,
/* item */	NULL,
/* cap */	edb_book_print_socialactivity
};
#ifdef	THE_UNIVERSITY_OF_TOKUSHIMA
DECLARE_PRINT_MODULE(socialactivity, module_info)
#endif

